# _Synimport_

## Чем занимается?
> Добавляет контент из подготовленных файлов(_о структуре директории и файлов см. ниже_).

## Версии
- [Drupal.org prod версия](https://www.drupal.org/project/synimport)

```sh
composer require 'drupal/synimport:^1.60'
```
- [Drupal.org dev версия](https://www.drupal.org/project/synimport/releases/8.x-1.x-dev)
```sh
composer require 'drupal/synimport:1.x-dev@dev
```
## Примеры файлов с контентом
Смотри папку _synimport/[content_file_examples](https://git.synapse-studio.ru/d-org/synimport/-/tree/master/content%20file%20examples)_

## Как использовать?
- **Полная версия**
```sh
cd html && drush synimport /путь/до/директории/с/файлами/контента
```
- **Только страница контактов**
```sh
cd html && drush synimport:contact /путь/до/директории/с/файлами/контента
```
- **Только ноды**
```sh
cd html && drush synimport:node /путь/до/директории/с/файлами/контента
```
- **Только меню**
```sh
cd html && drush synimport:menu /путь/до/директории/с/файлами/контента
```
- **Только термины таксономии**
```sh
cd html && drush synimport:taxonomy /путь/до/директории/с/файлами/контента
```
- **Только товары**
```sh
cd html && drush synimport:product /путь/до/директории/с/файлами/контента
```
- **Только блоки**
```sh
cd html && drush synimport:block /путь/до/директории/с/файлами/контента
```
- **Только synlanding _(картинка для блоков остались вопросы и формы в подвале)_**
```sh
cd html && drush synimport:synlanding_config /путь/до/директории/с/файлами/контента
```

## Структура директории для полного импорта _(для отдельных частей просто полный путь до директории с yml)_
_**(Все типы нод и прочего должны существовать на сайте(synimport не проверяет их на существование))**_

**_путь_к_папке_/**:
- **_путь_к_папке_/contacts** (_.yml для страницы контактов_)
- **_путь_к_папке_/block**
- **_путь_к_папке_/node**
- **_путь_к_папке_/product**
- **_путь_к_папке_/taxonomy** (_.yml терминов таксономии(дочерние термины указываются в .yml родителя)_)
- **_путь_к_папке_/synlanding** (_.yml synlanding конфигурация для фона блоков остались вопросы и формы в подвале_)

## Структура файлов
**Если поле типизированное:**
```yml
имя_поля:
    type: тип_поля
    content: значение
```
_**Досутпные типы:**_
- **image** _(для единичных и множественных по типу field_gallery)_
- **media**
- **attach** _(прикрепленный файл)_
- **taxonomy** _(ссылка на термин таксономии)_
- **paragraph**
- **variations** _(вариации для товаров)_
- **attribute** _(атрибут для вариации)_

_**Если указан неизвестный тип, то попытается взять как текстовое поле**_

**В общем случае _(без указания типа)_ :**
```yml
имя_поля: значение
```

## Основные сервисы
- Import (_Полный импорт(выполняет все, что дальше по списку_)
- Block
- Product
- Node
- Menu
- Taxonomy

## Доп сервисы
- Logger
- CreateEntity
- Files

## Требования к платформе
- _Drupal 8-9_
- _PHP 7.4.0+_
